Atelier Pièce

From FreeCAD Documentation
Jump to: navigation, search
This page is a translated version of the page Part Module and the translation is 97% complete.

Outdated translations are marked like this.

Les capacités CAO de FreeCAD sont basées sur le noyau OpenCasCade. L'établi pièce de FreeCAD permet d'accéder et utiliser les objets et les fonctions OpenCascade. OpenCascade est un noyau CAO de niveau professionnel, qui contient des fonctions avancées de manipulation de géométrie 3D et d'objets. Les objets pièces, contrairement aux objets maillages, sont beaucoup plus complexes, et permettent donc des opérations beaucoup plus avancées, telles que les opérations booléennes logiques, l'historique des modifications ou encore des comportements paramétriques.

Part example.jpg

Exemple de forme réalisée à l'aide de l'établi pièce

Les outils

Les outils de l'établi pièce sont situés dans le menu Pièce qui apparait lorsque l'on charge l'établi pièce.

Primitives

Voici les outils permettant de créer des primitives.

  • Part Box.png Cube: Dessine un cube en spécifiant ses dimensions.
  • Part Cone.png Cône: Dessine un cône en spécifiant ses dimensions.
  • Part Cylinder.png Cylindre: Dessine un cylindre en spécifiant ses dimensions.
  • Part Sphere.png Sphère: Dessine une sphère en spécifiant ses dimensions.
  • Part Torus.png Tore: Dessine un tore (anneau) en spécifiant ses dimensions.
  • Part CreatePrimitives.png CreatePrimitives: Outil pour créer différentes primitives géométriques paramétriques.
  • Part Shapebuilder.png Shapebuilder: Outil pour créer des formes complexes, de plusieurs primitives géométriques paramétriques.

Modifier les objets

Voici les outils permettant de modifier les objets existants. Ils vous permettront de choisir quels objets modifier.

  • Part Booleans.png Opérations booléennes: Réalise les principales opérations booléennes sur des objets.
  • Part Union.png Union: Fusionne (additionne) deux objets.
  • Part Common.png Intersection: Extrait la partie commune (intersection) de deux solides.
  • Part Cut.png Soustraction: Soustrait un objet à un autre.
  • Part JoinConnect.png Join features: Crée un raccord et joint des objets (ex., tubes) (v0.16)
    • Part JoinConnect.png Connect: Crée un raccord avec connexion interne de objets (v0.16)
    • Part JoinEmbed.png Embed: Intègre un objet clos dans un autre objet avec paroi (v0.16)
    • Part JoinCutout.png Cutout: Crée une découpe dans la paroi d'un objet pour ajouter un autre objet avec paroi (v0.16)
  • Coupes et séparation d'objets: (v0.17)
    • Part BooleanFragments.png Boolean fragments: Crée un objet avec chaque découpe booléenne créée entre divers pièces (v0.17)
    • Part Slice.png Slice: Découpe et sépare un objet à chaque intersection d'un autre objet (v0.17)
    • Part XOR.png XOR: Supprime l'espace partagé par un nombre pair d'objets (version symétrique de Cut) (v0.17)
  • Part Extrude.png Extrusion: Extrude les faces planes d'un objet.
  • Part Fillet.png Congé: Réalise un congé (arrondi) sur les arêtes d'un objet.
  • Part Revolve.png Révolution: Crée un objet par révolution d'un autre objet autour d'un axe.
  • Part Section.png Coupe: Crée une coupe par l'intersection d'un objet avec un plan de coupe.
  • Part SectionCross.png Plusieurs sections de coupes ...:
  • Part Chamfer.png Chanfrein: Chanfreine les arêtes d'un objet.
  • Part Mirror.png Miroir: Réalise la symétrie axiale de l'objet sélectionné autour d'un axe donné.
  • Part RuledSurface.png Ruled Surface:
  • Part Sweep.png Balayage: Balayage d'une ou plusieurs sections le long d'un chemin (tracé).
  • Part Loft.png Loft: Crée un lissage d'un profil jusqu'un autre profil
  • Part Offset.png Offset: Crée une copie à l'échelle de l'objet sélectionné.
  • Part Loft.png Lissage: Lissage d'une série de profils.

Autres outils

  • Part ImportCAD.png Import CAD: Cet outil ajoute un fichier de format *.IGES, *.STEP, *.BREP dans le document courant.
  • Part ExportCAD.png Export CAD: Cet outil exporte un objet Part en format *.IGES, *.STEP, *.BREP file.
  • Part ShapeFromMesh.png Shape from Mesh: Crée un objet shape en objet mesh.
  • Convert to solid: Conversion d'un objet en un objet solide.
  • Reverse shapes: Retourne les normales de toutes les faces de l'objet sélectionné.
  • Create simple copy: Crée une simple copie de l'objet sélectionné.
  • Make compound: Crée un composé avec les objets sélectionnés.
  • Part RefineShape.png Refine shape: Nettoie les faces et efface les lignes inutiles.
  • Part CheckGeometry.png Check geometry: Vérifie la géométrie des objets sélectionnés pour détecter les éventuelles erreurs.
  • Measure: Donne une mesure linéaire entre point/edges/faces.



Opérations booléennes

Un exemple d'addition (Union), d'intersection et de différence (Soustraction)


Un exemple d'addition (Union), d'intersection et de différence (Soustraction)

Explication des concepts

Dans la terminologie OpenCascade, nous faisons la distinction entre les primitives géométriques et les formes (topologiques). Une primitive géométrique peut être un point, une ligne, un cercle, un plan, etc. ou même certains types plus complexes, comme une courbe B-Spline ou une surface. Une forme (shape en anglais) peut être un sommet, une arête, un fil, une face, un solide ou un composé d'autres formes. Les primitives géométriques ne sont pas faites pour être affichées directement sur la scène 3D, mais plutôt pour être utilisées comme géométrie de construction des formes. Par exemple, une arête peut être construite à partir d'une ligne ou d'une partie de cercle.

On pourrait donc dire, pour résumer, que les primitives géométriques sont des blocs de construction "informes", et que les formes sont les véritables entités géométriques spatiales construites sur ces blocs.

Pour obtenir une liste complète de tous ces éléments, se référer à la documentation OCC et rechercher Geom_Geometry et TopoDS_Shape. Là, vous pourrez également en savoir plus sur les différences entre les objets géométriques et les formes. À notre grand regret, la documentation OCC n'est malheureusement pas disponible en ligne (vous devez télécharger une archive) et est principalement destiné aux programmeurs et non aux utilisateurs finaux. Mais espérons que vous trouverez suffisamment d'informations pour commencer ici.

Les types géométriques peuvent en fait être divisés en deux groupes principaux: les courbes et les surfaces. Sur les courbes (ligne, cercle, ...) vous pouvez directement créer une arête, sur les surfaces (plan, cylindre, ...) une face peut être construite. Par exemple, la ligne primitive géométrique est illimitée, c'est à dire qu'elle est définie par un vecteur de base et un vecteur directeur tandis que la forme associée (et représentée) doit être quelque chose de limité par un début et de fin. Et un cube - un solide - peut être créée par six plans limités.

En contrepartie, il est également possible, depuis une arête ou une face, de revenir à sa primitive géométrique.

Ainsi, en se basant sur les formes, vous pouvez construire des pièces très complexes ou, dans l'autre sens, extraire tous les sous-formes dont est faite une forme plus complexe.

Les scripts

La structure principale de données utilisée dans l'établi pièce est le type de données BRep d'OpenCascade. Presque tous les contenus et les types d'objets de l'établi pièce sont maintenant disponibles pour les scripts python. Cela inclut les primitives géométriques, telles que les lignes (Line) et les cercles (Circle ou Arc), et l'ensemble des TopoShapes, tels que les vertex, arêtes, fils, faces, solides et composés. Pour chacun de ces objets, plusieurs méthodes de création existent, et pour certains d'entre eux, en particulier les TopoShapes, des opérations avancées telles que les opérations booléennes union / soustraction / intersection sont également disponibles. Explorez le contenu de l'établi pièce, tel que décrit dans la page Les bases du langage de script de FreeCAD, pour en savoir plus.

Exemples

Pour créer un élément ligne, passer à la console Python et taper:

import Part,PartGui 
doc=App.newDocument()  
l=Part.Line()
l.StartPoint=(0.0,0.0,0.0)
l.EndPoint=(1.0,1.0,1.0)
doc.addObject("Part::Feature","Line").Shape=l.toShape() 
doc.recompute() 

Passons en revue l'exemple python ci-dessus étape par étape:

import Part,PartGui
doc=App.newDocument() 

charge l'établi pièce et crée un nouveau document

l=Part.Line()
l.StartPoint=(0.0,0.0,0.0)
l.EndPoint=(1.0,1.0,1.0) 

La fonction Line décrit en fait un segment de ligne, d'où le point de départ et le point final.

doc.addObject("Part::Feature","Line").Shape=l.toShape() 

Cette commande ajoute un objet de type pièce au document et affecte la représentation de forme du segment de ligne à la propriété 'forme' ('Shape') de l'objet ajouté. Il est important de comprendre ici que nous avons utilisé une primitive géométrique (la Part.line) pour créer un TopoShape à partir de celle-ci (la méthode toShape()). Seules les formes peuvent être ajoutées au document. Dans FreeCAD, les primitives géométriques sont utilisées comme des "structures de base" pour construire les formes.

doc.recompute() 

Mise à jour du document. Cela prépare également la représentation visuelle du nouvel objet pièce.

Notez qu'une ligne peut être créée en spécifiant son point de départ et son point final directement dans le constructeur, par ex. Part.Line (point1, point2) ou nous pouvons créer une ligne par défaut et définir ses propriétés après, comme nous l'avons fait ici.

Un cercle peut être créé de la même manière:

import Part
doc = App.activeDocument()
c = Part.Circle() 
c.Radius=10.0  
f = doc.addObject("Part::Feature", "Circle")
f.Shape = c.toShape()
doc.recompute() 

Notez qu'une fois encore, nous avons utilisé le cercle (primitive géométrique) pour construire une forme. Nous pouvons bien sûr toujours accéder à notre géométrie de construction par la suite, en faisant:

s = f.Shape
e = s.Edges[0]
c = e.Curve 

Ici on prend la forme de notre objet f, puis nous prenons la liste de ses arêtes. Dans ce cas il y aura une seule arête parce que nous avons fait toute la forme à partir d'un cercle unique, c'est pourquoi nous ne prenons que le premier élément de la liste des arêtes, et puis nous récupérons sa courbe. Chaque arête a une courbe, qui est la géométrie primitive, sur laquelle elle est basée.

Rendez-vous sur la page Les scripts de pièces si vous voulez en savoir plus.

Tutorials

< précédent: OpenSCAD Module
suivant: Drawing Module >
Other languages:
čeština • ‎Deutsch • ‎English • ‎español • ‎français • ‎Bahasa Indonesia • ‎italiano • ‎polski • ‎português • ‎português do Brasil • ‎română • ‎русский • ‎svenska • ‎Türkçe • ‎українська • ‎中文 • ‎中文(台灣)‎